import 'dart:ffi';

import 'package:flutter/material.dart';
import 'dart:async';

import 'package:flutter/services.dart';
import 'package:ecom_flutter_plugin/ecom_flutter_plugin.dart';
import 'native_message.dart';
void main() {
  runApp(const MyApp());
}

class MyApp extends StatefulWidget {
  const MyApp({Key? key}) : super(key: key);

  @override
  State<MyApp> createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  String _platformVersion = 'Unknown';

  @override
  void initState() {
    super.initState();
    initNativeMessage();
  }

  initNativeMessage(){
    NativeMessage.initPlugin();
  }

  // Platform messages are asynchronous, so we initialize in an async method.
  Future<void> initPlatformState() async {
    String platformVersion;
    // Platform messages may fail, so we use a try/catch PlatformException.
    // We also handle the message potentially returning null.
    try {
      platformVersion = await EcomFlutterPlugin()
          .postToNative("action1111", {"0009": "3333333"});
    } on PlatformException {
      platformVersion = 'Failed to get platform version.';
    }
    // If the widget was removed from the tree while the asynchronous platform
    // message was in flight, we want to discard the reply rather than calling
    // setState to update our non-existent appearance.
    if (!mounted) return;

    setState(() {
      _platformVersion = platformVersion;
    });
  }

  _action() async {
    String name;
    try {
      name = await NativeMessage.postToNative("userinfo", {"name":"我是Flutter向原生发送的消息"});
    } catch (e) {
      name = "错误了老弟";
    }

    setState(() {
      buttonName = name;
    });
  }


  String buttonName = "我是按钮";
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Plugin example app'),
        ),
        body: Center(
            child: Column(
          children: [
            Container(
              alignment: Alignment.center,
              height: 90,
              child: Text('Running on1: $_platformVersion\n'),
            ),
            TextButton(onPressed: _action, child: Text(buttonName))
          ],
        )),
      ),
    );
  }
}
